<template>
  <h1>Add User</h1>
  <!-- ฟอร์มกรอกข้อมูลที่ต้องการเพื่ม -->
  <form @submit.prevent="submit">
    <v-text-field
      v-model="fname.value.value"
      :error-messages="fname.errorMessage.value"
      label="First Name"
    ></v-text-field>
    <v-text-field
      v-model="lname.value.value"
      :error-messages="lname.errorMessage.value"
      label="Last Name"
    ></v-text-field>
    <v-text-field
      v-model="username.value.value"
      :error-messages="username.errorMessage.value"
      label="Username"
    ></v-text-field>
    <v-text-field
      v-model="password.value.value"
      :error-messages="password.errorMessage.value"
      label="Password"
    ></v-text-field>
    <v-text-field
      v-model="email.value.value"
      :error-messages="email.errorMessage.value"
      label="Email"
    ></v-text-field>
    <v-text-field
      v-model="avatar.value.value"
      :error-messages="avatar.errorMessage.value"
      label="Avata"
    ></v-text-field>
    <!-- Submit and Clear buttons -->
    <v-btn class="me-4" type="submit"> submit </v-btn>
    <v-btn @click="handleReset"> clear </v-btn>
  </form>
</template>

<script>
import { ref } from "vue";
import { useField, useForm } from "vee-validate";
import { useRouter } from "vue-router";

export default {
  setup() {
    const router = useRouter();
    // การเช็คตรวจจับการกรอกข้อมูล
    const { handleSubmit,handleReset } = useForm({
    // การตรวจสอบสำหรับการกรอกข้อมูลในแบบฟอร์ม
      validationSchema: {
        // Frist name
        fname(value) {
          if (value?.length >= 2) return true;

          return "First name needs to be at least 2 characters.";
        },
        // Last name
        lname(value) {
          if (value?.length >= 2) return true;

          return "Last name needs to be at least 2 characters.";
        },
        // Username
        username(value) {
          if (value?.length >= 2) return true;

          return "Username needs to be at least 6 characters.";
        },
        // Password
        password (value) {
            if (value?.length >= 8) return true

            return 'Password needs to be at least 8 characters.'
        },
        // Email
        email (value) {
            if (/^[a-z.-]+@[a-z.-]+\.[a-z]+$/i.test(value)) return true

            return 'Must be a valid e-mail.'
        },
        // Avatar
        avatar (value) {
            if (value?.length >= 1) return true

            return 'avatar needs to link avatar.'
        },
      },
    });

    const fname = useField("fname");
    const lname = useField("lname");
    const username = useField("username");
    const password = useField("password");
    const email = useField("email");
    const avatar = useField("avatar");
    
    const runtimeConfig = useRuntimeConfig();
    const URL = runtimeConfig.public.URL_Auth;
    console.log("URL : ",URL)
    // การบันทึกข้อมูลที่ต้องการเพื่ม 
    const submit = handleSubmit(async () => {
      try {
        
        var myHeaders = new Headers();
        myHeaders.append("Content-Type", "application/json");

        var raw = JSON.stringify({
          "fname": fname.value.value,
          "lname": lname.value.value,
          "username": username.value.value,
          "password": password.value.value,
          "email": email.value.value,
          "avatar": avatar.value.value
        });
        console.log("Before edited to sent", raw) // console.log ก่อนส่งข้อมูลการแก้ไขข้อมูลว่าแก้ไขอะไรบ้าง
        console.info("Before info edited data:", raw); // console.log ก่อนส่งข้อมูลการแก้ไขข้อมูลว่าแก้ไขอะไรบ้าง
        console.debug("Before DeBug Fetched edited data:", raw); // console.log ตรวจหา deBug ก่อนส่งข้อมูลไป
        console.error("Before Error Fetched edited data:", raw); // console.log ตรวจหา error ก่อนส่งข้อมูลไป

        var requestOptions = {
          method: 'POST',
          headers: myHeaders,
          body: raw,
          redirect: 'follow'
        };

        const response = await fetch(`${URL}/api/users/create`, requestOptions);
        const result = await response.json();
        alert("Create new user success"); // แจ้งเตือนการเพิ่มข้อมูล
        console.log('After create data:', result); // console.log การแก้ไขข้อมูลหลังจากถูกแก้ไขว่าแก้ไขอะไรบ้าง
        console.info('After info create data:', result); // console.log การแก้ไขข้อมูลหลังจากถูกแก้ไขว่าแก้ไขอะไรบ้าง
        console.debug('After DeBug create data:', result); // console.log ตรวจหา deBug หลังจากส่งข้อมูลไปแล้ว
        console.error('After Error create data:', result); // console.log ตรวจหา error หลังจากส่งข้อมูลไปแล้ว
        const currentDate = new Date();
        const formattedDate = currentDate.toLocaleDateString() + ' ' + currentDate.toLocaleTimeString();
        console.log('Adding data at:', formattedDate);  // console.log วันและเวลาที่เพิ่มข้อมูล
        if (result.status === 'ok'){
          
          router.push("/kissada/tableAPI");  
        }
      } catch (error) {
        console.log('Error creaet data', error);
      }
    });

    return {
      fname,
      lname,
      username,
      password,
      email,
      avatar,
      submit,
      handleReset,
    };
  },
};
</script>